{% include './header.html' %}

<div class="container">
    <div id="welcome">
        <p>Please type a text to be analysed for named entities (e.g. person, location).</p>
        <p><strong>Example sentence:</strong> <i>In Sachsen und Brandenburg hat die CDU bei den Wahlen stark verloren, vor allem an die AfD. Schleswig-Holsteins Ministerpräsident Daniel Günther spricht von einem Alarmsignal.</i></p>
    </div>

    <form id="form_user_input" method="get" action="">
      <input id="msg" type="text" class="form-control" name="msg" autofocus="autofocus" placeholder="Text snippet"/>
      <input type="submit" class="btn btn-primary" style="background-color:#0000ff; margin-top: 10px" value="Send"/>
    </form>

    <div id="result"></div>

</div>

{% include './footer.html' %}

<script>

function selectAllFilters(){
        $('#loc_sel').prop('checked', true);
        $('#org_sel').prop('checked', true);
        $('#per_sel').prop('checked', true);
        $('#tem_sel').prop('checked', true);
        $('#oth_sel').prop('checked', true);
        $('#act_sel').prop('checked', true);
}

function filterTextJSON(text,id,checked){
	var text2 = "[ { \"@id\": \"http://qurator.ai/documents/1567157592.6347563#char=31,44\", " +
	"\"@type\": [ \"http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#String\" ], " +
	"\"http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#anchorOf\": [ { \"@value\": \"Angela Merkel\" } ], " +
	"\"http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#beginIndex\": [ { \"@type\": \"http://www.w3.org/2001/XMLSchema#nonNegativeInteger\", \"@value\": \"31\" } ], " +
	"\"http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#endIndex\": [ { \"@type\": \"http://www.w3.org/2001/XMLSchema#nonNegativeInteger\", \"@value\": \"44\" } ], " +
	"\"http://www.w3.org/2005/11/its/rdf#taClassRef\": [ { \"@value\": \"http://dbpedia.org/ontology/Person\" } ] }, { \"@id\": \"http://qurator.ai/documents/1567157592.6347563#char=0,44\", \"@type\": [ \"http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#String\", \"http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#Context\" ], \"http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#beginIndex\": [ { \"@type\": \"http://www.w3.org/2001/XMLSchema#nonNegativeInteger\", \"@value\": \"0\" } ], \"http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#endIndex\": [ { \"@type\": \"http://www.w3.org/2001/XMLSchema#nonNegativeInteger\", \"@value\": \"44\" } ], \"http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#isString\": [ { \"@value\": \"Welcome to Berlin in 2016 with Angela Merkel\" } ] } ]";
//      alert('the text is properly defined.');
	var obj = JSON.parse(text);
//    alert("JSON properly parsed.");
    filterJSON(obj,id,checked);
}

function filterJSON(obj,id,checked){
        //var graph = obj["@graph"];
        var graph = obj;
//        alert(obj);
        var text = '';
        var entityArray = new Array();
        var eventsArray = new Array();
        $('#processedTextArea').html(text);
        var sortable = [];
        var sortableEvent = [];
        //alert(entityArray.length);
        for(i = 0; i < graph.length; i++) {
        		var isContext = false;
                for(j = 0; j < graph[i]["@type"].length; j++) {
                        //alert(graph[i]["@type"][j]);
                        if(graph[i]["@type"][j]==='http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#Context'){
                                text = graph[i]["http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#isString"][0]["@value"];
                                isContext = true;
                        }
                }
                if(!isContext){
                	if(graph[i]["http://www.w3.org/2005/11/its/rdf#taIdentRef"]==undefined){
		                var entity = {bi:graph[i]["http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#beginIndex"][0]["@value"],
    	            			  	  ei:graph[i]["http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#endIndex"][0]["@value"],
        	        			  	  cr:graph[i]["http://www.w3.org/2005/11/its/rdf#taClassRef"][0]["@value"],
            	    			  	  ir:"null",
                				  	  id:graph[i]["@id"]};
                	}
                	else{
		                var entity = {bi:graph[i]["http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#beginIndex"][0]["@value"],
    	            			  	  ei:graph[i]["http://persistence.uni-leipzig.org/nlp2rdf/ontologies/nif-core#endIndex"][0]["@value"],
        	        			  	  cr:graph[i]["http://www.w3.org/2005/11/its/rdf#taClassRef"][0]["@value"],
            	    			  	  ir:graph[i]["http://www.w3.org/2005/11/its/rdf#taIdentRef"][0]["@value"],
                				  	  id:graph[i]["@id"]};
                	}
					sortable.push([entity.bi, entity.ei, entity.cr, entity.ir, entity.id]);
        	        entityArray[i] = entity;
        	    }
        }
//        alert("TEXT: "+text)
        text = text.replace(/&amp;/g, "&");
        text = text.replace(/&/g, "&");
        sortable.sort(
                        function(a, b) {
                        return a[0] - b[0]
                        }
                     )
        sortableEvent.sort(
                        function(a, b) {
                        return a[0] - b[0]
                        }
                     )
//		for(i = 0; i < sortable.length; i++) {
//        	alert(sortable[i][2]);
//        }

		var offset = 0;
        var high = "";

        var continuousOffset = 0;
//        $('#eventsBox').html('');
//        for(i = 0; i < sortableEvent.length; i++) {
//                $('#eventsBox').html($('#eventsBox').html()+'<div class="checkbox" id="event101">'+sortableEvent[i][1]+' ('+sortableEvent[i][3]+') '+sortableEvent[i][5]+' ('+sortableEvent[i][7]+')');
//        }

        for(i = 0; i < sortable.length; i++) {
//	        	alert(sortable[i][2]);

                $('#processedTextArea').html($('#processedTextArea').html()+'<br/>'+graph[i]["nif:anchorOf"]+','+sortable[i][0]+','+sortable[i][1]+','+sortable[i][2]);
                var label = '';
                if(sortable[i][2]!==undefined){
//                        alert(sortable[i][2]);
                        if(sortable[i][2].includes("Location")){
                                label = 'label-primary';
                        }
                        else if(sortable[i][2].includes("Organisation")){
                                label = 'label-success';
                        }
                        else if(sortable[i][2].includes("Person")){
                                label = 'label-warning';
                        }
                        else if(sortable[i][2].includes("TemporalEntity")){
                                label = 'label-danger';
                        }
                        else if(sortable[i][2].includes("Action")){
                                label = 'label-info';
                        }
                        else if(sortable[i][2].includes("Thing")){
                                label = 'label-default';
                        }
                        else{
                                label = 'label-default';
                        }
                        //alert("Entramos:"+sortable[i][0]+","+sortable[i][1]+","+offset);

                        if(parseInt(offset,10)>parseInt(sortable[i][1],10)){
                        //      alert(sortable[i][0]+","+sortable[i][1]);
                                high = high + "<span class=\"label "+label+" annotatedEntity\" entityId=\""+sortable[i][4]+"\" url=\""+sortable[i][3]+"\" start=\""+sortable[i][0]+"\" end=\""+sortable[i][1]+"\" onclick=\"callFeedbackWindow(this)\">";
                                high = high + text.substring(sortable[i][0], sortable[i][1]);
                                high = high + "</span>";
                        }
                        else{
                                var partText = text.substring(offset, sortable[i][0]);
                        //      alert("Entramos con:"+partText+"("+offset+","+ sortable[i][0]+")");
                                if(partText && partText.length>0){
                                        //var res = partText.split(" ");
                                        var res = partText.split(/\s/);
                                        for(z = 0; z < res.length; z++) {
                                                //alert("Parte "+z+": "+res[z]);
                                                if(res[z].length>0){
                                                        var newOffset = parseInt(offset,10) + parseInt(res[z].length,10);
                                                        high = high + "<span class=\"notAnnotatedEntity\" url=\"\" start=\""+offset+"\" end=\""+newOffset+"\" >";
                                                        high = high + text.substring(offset,newOffset);
                                                        high = high + "</span>";
                                                        high = high + " ";
                                                        offset = parseInt(newOffset,10)+1;
                                                }
                                                else{
                                                        offset++;
                                                        high = high + " ";
                                                }
                                        }
                                }
                                //high = high + text.substring(offset, sortable[i][0]);
                                high = high + "<span class=\"label "+label+" annotatedEntity\" entityId=\""+sortable[i][4]+"\" url=\""+sortable[i][3]+"\" start=\""+sortable[i][0]+"\" end=\""+sortable[i][1]+"\">";
                                high = high + text.substring(sortable[i][0], sortable[i][1]);
                                high = high + "</span>";
                        }

                        offset = parseInt(sortable[i][1],10);
                }
        }
        //high = high + text.substring(offset);
        var partText = text.substring(offset);
        if(partText && partText.length>0){
                var res = partText.split(" ");
                for(z = 0; z < res.length; z++) {
                        if(res[z].length>0){
                                var newOffset = parseInt(offset,10) + parseInt(res[z].length,10);
                                high = high + "<span class=\"notAnnotatedEntity\" url=\"\" start=\""+offset+"\" end=\""+newOffset+"\" >";
                                high = high + text.substring(offset,newOffset);
                                high = high + "</span>";
                                high = high + " ";
                                offset = newOffset+1;
                        }
                        else{
                                offset++;
                        }
                }
        }
//        alert("HIGH TEXT: "+high);
        $('#processedTextArea').html(high);
}

//var data = $('#nifContentDiv').html();
//selectAllFilters();
//filterTextJSON(data,'','');

//$('.annotatedEntity').click(function(e) {
//	var ent_text = $(this).html();
//    //alert(ent_text);
//    $('body').addClass("loading2");
//    $('#feedbackEntityText').html(ent_text);
//});

// Attach a submit handler to the form
$( "#form_user_input" ).submit(function( event ) {

  // Stop form from submitting normally
  event.preventDefault();

  // Get form field value
  var msg = $("#msg").val();

  // clear form field
  $("#msg").val("");

  // clear result div
  $("#result").html("");
  $( "#result" ).append( '<p class="alert alert-warning" style="margin-top: 10px;">It takes about 20 seconds to calculate the result. Thanks for your patience.</strong>.</p>');

  // Send the data using ajax
//  alert(msg);
  $.ajax({
    url: "https://demo.qurator.ai/pub/srv-bertner-de/spotEntities",
    type: 'GET',
    data: {
        "informat": "txt",
        "outformat": "json-ld",
        "input": msg
    },
    contentType: 'text/plain',
    error : function(err) {
        console.log('Error!', err);
        //alert("Error!!");
    },
    success: function(data) {
        console.log('Success!');
        //alert("Success!: "+data);
//        $( "#result" ).append( '<p class="alert alert-info" style="margin-top: 10px;"><strong>' + data + '</strong>.</p>');
		$("#result").html("");
        $( "#result" ).append( '<div class="alert alert-info" style="margin-top: 10px;"><div class="form-group" id="processedTextArea"></div></div>');
		selectAllFilters();
		filterTextJSON(data,'','');
    }
  });

//alert("DONE");
});

//$( "#result" ).append( '<div class="alert alert-info" style="margin-top: 10px;"><div class="" id="processedTextArea"></div></div>');
//selectAllFilters();
//filterTextJSON('','','');

</script>
</body>
</html>
